/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "setup_panel.h"

FD_setup_panel *create_form_setup_panel(void)
{
	FL_OBJECT *obj;
	FD_setup_panel *fdui = (FD_setup_panel *) fl_calloc(1, sizeof(*fdui));

	fdui->setup_panel = fl_bgn_form(FL_NO_BOX, 570, 310);
	obj = fl_add_box(FL_UP_BOX, 0, 0, 570, 310, "");

	fdui->bits_group = fl_bgn_group();
	fdui->bits16_button = obj = fl_add_checkbutton(FL_RADIO_BUTTON, 170, 30, 100, 30, "16 bits");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fdui->bits8_button = obj = fl_add_checkbutton(FL_RADIO_BUTTON, 170, 60, 100, 30, "8 bits");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_end_group();

	fdui->interp_button = obj = fl_add_checkbutton(FL_PUSH_BUTTON, 280, 30, 100, 30, "Interpolation");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
	fdui->channels_group = fl_bgn_group();
	fdui->stereo_button = obj = fl_add_checkbutton(FL_RADIO_BUTTON, 30, 30, 100, 30, "Stereo");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fdui->mono_button = obj = fl_add_checkbutton(FL_RADIO_BUTTON, 30, 60, 100, 30, "Mono");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_end_group();


	fdui->buttons_group = fl_bgn_group();
	fdui->accept_button = obj = fl_add_button(FL_NORMAL_BUTTON, 440, 40, 90, 40, "ACCEPT");
	/*fl_set_object_shortcut(obj, "A,a",1)*/
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj, accept_button_callback, 0);

	fdui->defaults_button = obj = fl_add_button(FL_NORMAL_BUTTON, 440, 120, 90, 40, "DEFAULTS");
	/*fl_set_object_shortcut(obj, "D,d", 1);*/
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj, defaults_button_callback, 0);

	fdui->cancel_button = obj = fl_add_button(FL_NORMAL_BUTTON, 440, 200, 90, 40, "CANCEL");
	/*fl_set_object_shortcut(obj, "C,c", 1);*/
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);
	fl_set_object_callback(obj, cancel_button_callback, 0);

	fl_end_group();
	fl_set_object_bw(fdui->buttons_group, -2);


	fdui->inputs_group = fl_bgn_group();
	fdui->frequency_input = obj = fl_add_input(FL_INT_INPUT, 270, 100, 110, 30, "Mixing Frequency : ");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_callback(obj, frequency_input_callback, 0);
	fdui->mixer_path_input = obj = fl_add_input(FL_NORMAL_INPUT, 30, 160, 350, 30, "Mixer Path :");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_TOP_LEFT);
	fdui->playlist_dir_input = obj = fl_add_input(FL_NORMAL_INPUT, 30, 210, 350, 30, "Playlist Directory :");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_TOP_LEFT);
	fdui->module_dir_input = obj = fl_add_input(FL_NORMAL_INPUT, 30, 260, 350, 30, "Module Directory :");
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_TOP_LEFT);
	fl_end_group();
	fl_set_object_bw(fdui->inputs_group, -2);

	fl_end_form();
	
	fdui->updated = 0;
	return fdui;
}

void set_parameters(play_parameters * p)
{
	char tmp[10];
	
	if ( p->flags & PF_STEREO )
	{
		fl_set_button(setup->stereo_button, 1);
		fl_set_button(setup->mono_button, 0);
	} else
	{
		fl_set_button(setup->stereo_button, 0);
		fl_set_button(setup->mono_button,1);
	}
	if ( p->flags & PF_16BITS )
	{
		fl_set_button(setup->bits16_button, 1);
		fl_set_button(setup->bits8_button, 0);
	} else
	{
		fl_set_button(setup->bits16_button, 0);
		fl_set_button(setup->bits8_button, 1);
	}
	if ( p->flags & PF_INTERPOLATION )
		fl_set_button(setup->interp_button, 1);
	else
		fl_set_button(setup->interp_button, 0);
	sprintf(tmp, "%d",p->frequency);
	fl_set_input(setup->frequency_input, tmp);
	fl_set_input(setup->mixer_path_input, p->mixer_path);
	fl_set_input(setup->playlist_dir_input, p->playlist_dir);
	fl_set_input(setup->module_dir_input, p->module_dir);
}

void get_parameters(play_parameters * p)
{
	char tmp[10];
	int	tp, f;

	tp  = 0;
	if ( fl_get_button(setup->bits16_button) ) tp |= PF_16BITS;
	if ( fl_get_button(setup->stereo_button) ) tp |= PF_STEREO;
	if ( fl_get_button(setup->interp_button) ) tp |= PF_INTERPOLATION;
	strcpy(p->mixer_path, fl_get_input(setup->mixer_path_input));
	strcpy(p->playlist_dir, fl_get_input(setup->playlist_dir_input));
	strcpy(p->module_dir, fl_get_input(setup->module_dir_input));
	strcpy(tmp, fl_get_input(setup->frequency_input));
	f = strtol(tmp, NULL, 0);
	if ( (tp != p->flags) || (f != p->frequency) )
	{
		p->flags = tp;
		p->frequency = f;
		setup->updated = 1;
	}
} 
/*---------------------------------------*/

